<?php
/*
Plugin Name: Focus Area Maturity Matrix Component
Description: Add Focus Area Maturity Matrices to any Wordpress web site.
Version: 1.0
Author: dr. Slinger Jansen, Utrecht University
*/

function fam_matrix_tables() { 

    global $table_prefix, $wpdb;

        $tblname = 'fam_matrix';
        $wp_track_table = $table_prefix .$tblname;
       
        require_once( ABSPATH . '/wp-admin/includes/upgrade.php' );

        if($wpdb->get_var( "show tables like '$wp_track_table'" ) != $wp_track_table) 
        {

            $sql = "CREATE TABLE `". $wp_track_table . "` ( ";
            $sql .= "  `id`  int(11)   NOT NULL auto_increment, ";
            $sql .= "  `name` varchar(500) DEFAULT NULL, ";
            $sql .= "  `maturity_name` varchar(500) DEFAULT NULL, ";
            $sql .= "  `maturity_desc` text, ";
            $sql .= "  `maturity_level` int(11) NOT NULL, ";
            $sql .= "  `focus_name` varchar(500) NOT NULL, ";
            $sql .= "  `focus_desc` text, ";
            $sql .= "  `focus_number` int(11) NOT NULL, ";
            $sql .= "  `step` int(11) NOT NULL DEFAULT '1', ";
            $sql .= "  `maturity_name_values` text, ";
            $sql .= "  `maturity_desc_values` text, ";
            $sql .= "  `focus_title_values` text, ";
            $sql .= "  `focus_name_values` text, ";
            $sql .= "  `focus_desc_values` text, ";
            $sql .= "  `lvl_count` int(11) NOT NULL DEFAULT '0', ";            
            $sql .= "  PRIMARY KEY (`id`) "; 
            $sql .= ") ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ; ";

            
            dbDelta($sql);
        }
        $tblname = 'fam_matrix_instance';
        $instance = $table_prefix .$tblname;
        if($wpdb->get_var( "show tables like '$instance'" ) != $instance) 
        {

            $sql = "CREATE TABLE `". $instance . "` ( ";
            $sql .= "  `id`  int(11)   NOT NULL auto_increment, ";
            $sql .= "  `matrix_id` int(11) NOT NULL, ";
            $sql .= "  `name` varchar(100) NOT NULL, ";                             
            $sql .= "  `description` text, ";                       
            $sql .= "  PRIMARY KEY (`id`) "; 
            $sql .= ") ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ; ";

           
            dbDelta($sql);
        }

        $tblname = 'fam_matrix_values';
        $wp_track_table = $table_prefix .$tblname;
       
       
        if($wpdb->get_var( "show tables like '$wp_track_table'" ) != $wp_track_table) 
        {

            $sql = "CREATE TABLE `". $wp_track_table . "` ( ";
            $sql .= "  `id`  int(11) NOT NULL auto_increment, ";
            $sql .= "  `matrix_id` int(11) NOT NULL, ";
            $sql .= "  `instance_id` int(11) NOT NULL, ";
            $sql .= "  `focus_position` int(11) NOT NULL, ";
            $sql .= "  `start_cell` int(11) NOT NULL, ";
            $sql .= "  `end_cell` int(11) NOT NULL, ";
            $sql .= "  `cell_position` int(11) NOT NULL, ";
            $sql .= "  `title` varchar(250) NOT NULL, ";
            $sql .= "  `description` text, ";
            $sql .= "  `level` varchar(100) NOT NULL, ";
            $sql .= "  `colored` enum('0','1','2') NOT NULL DEFAULT '2', ";                   
            $sql .= "  PRIMARY KEY (`id`) "; 
            $sql .= ") ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ; ";

            
            dbDelta($sql);
        }

       

      
}




// run the install scripts upon plugin activation
register_activation_hook(__FILE__, 'fam_matrix_tables');

add_action('admin_menu','fam_matrix_admin_menu');

function fam_matrix_admin_menu() {    
    
    add_menu_page(__('Maturity Matrices'),
    __('Maturity Matrices'),
    'manage_options',
    'fam_matrix_admin', 
    'fam_matrix_admin',
    plugins_url('/fam_matrix/assets/images/matrix.png') 
    );

    //this is a submenu
    add_submenu_page('fam_matrix_admin', //parent slug
    __('Instances'), //page title
    __('Instances'), //menu title
    'manage_options', //capability
    'fam_matrix_instance', //menu slug
    'fam_matrix_instance'); //function

    add_submenu_page('fam_matrix_admin', //parent slug
    __('Documentation'), //page title
    __('Documentation'), //menu title
    'manage_options', //capability
    'fam_matrix_documentation', //menu slug
    'fam_matrix_documentation'); //function
}

add_action('admin_enqueue_scripts', 'fam_matrix_media'); 
add_action('wp_enqueue_scripts', 'fam_matrix_media');

function fam_matrix_media()
    {
        wp_enqueue_script( 'jquery-ui-datepicker','', array( 'jquery' ) );

     //  wp_enqueue_style( 'wp-color-picker' );

       // wp_enqueue_script( 'fam-script-handle', plugins_url( '/famlex_matrix/assets/js/custom-script.js' ), array( 'wp-color-picker' ), false, true ); 

        wp_register_style( 'fam_mm_css', plugins_url('/fam_matrix/assets/css/style.css') );
        wp_enqueue_style( 'fam_mm_css' );

        wp_register_style( 'fam_mm_css_datatable', plugins_url('/fam_matrix/assets/css/data-table.css') );
        wp_enqueue_style( 'fam_mm_css_datatable' );

       //  wp_register_style( 'fam_mm_css_datatable_selectable', plugins_url('/fam_matrix/assets/css/select.dataTables.min.css') );
       // wp_enqueue_style( 'fam_mm_css_datatable_selectable' );

        wp_register_style( 'fam_mm_css_scheduler', plugins_url('/fam_matrix/assets/css/jquery.scheduler.css') );
        wp_enqueue_style( 'fam_mm_css_scheduler' );
       
        wp_enqueue_script( 'fam_mm_js_admin_datatable', plugins_url('/fam_matrix/assets/js/data-table.js'), array( 'jquery' ) );

         wp_enqueue_script( 'fam_mm_js_admin_dateformate', plugins_url('/fam_matrix/assets/js/date.format.min.js'), array( 'jquery' ) );


     //   wp_enqueue_script( 'fam_mm_js_admin_datatable_selectable', plugins_url('/fam_matrix/assets/js/dataTables.select.min.js'), array( 'jquery' ) );
       
    }

add_action("wp_ajax_fam_matrix_data", "fam_matrix_data");
add_action("wp_ajax_fam_matrix_data_delete", "fam_matrix_data_delete");


function fam_matrix_data()
{  
    if(isset($_POST['cel_val']) and $_POST['cel_val'] != '')
    { 
        $inputval = trim($_POST['inputval']);
        $ttl_input = trim($_POST['ttl_input']);
        $dsc_input = trim($_POST['dsc_input']);
        $cel_val = trim($_POST['cel_val']);
        $matrix = trim($_POST['matrix']);
        $instance = trim($_POST['instance']);
        $colored = $_POST['colored'];

        if($colored == 1)
            $colored = '1';
        else
            $colored = '2';

        $split_val = explode('_', $cel_val);

        global $wpdb;
        $matrix_table = $wpdb->prefix."fam_matrix_values";

        if(count($split_val) > 1)
        {
        $focus_position = (int)$split_val[0];
        $start_cell = (int)$split_val[1];
        $end_cell = (int)$split_val[2];
        $cell_position = (int)$split_val[3];         

         $exists = $wpdb->get_row("SELECT id FROM ".$matrix_table." WHERE matrix_id = ".$matrix." AND instance_id = ".$instance." AND focus_position = ".$focus_position." AND start_cell=".$start_cell." AND end_cell=".$end_cell." AND cell_position=".$cell_position );
        }
        else
        {
            $exists = $wpdb->get_row("SELECT id FROM ".$matrix_table." WHERE id = ".(int)$split_val[0]);
        }

         if(count($exists) > 0)
         {
             $wpdb->update($matrix_table, array('title'=>$ttl_input, 'description'=>$dsc_input, 'level'=>$inputval,'colored'=>$colored), array('id'=>$exists->id));


             $lastid = $exists->id;
         }
         else
         {
             $datas = array('matrix_id'=>$matrix,'instance_id'=>$instance,'focus_position'=> $focus_position,'start_cell'=>$start_cell,'end_cell'=>$end_cell,'cell_position'=>$cell_position,'title'=>$ttl_input,'description'=>$dsc_input,'level'=>$inputval,'colored'=>$colored);    

             $data_types = array('%d','%d','%d','%d','%d','%d','%s','%s','%s','%s');

             $wpdb->insert($matrix_table,$datas,$data_types);           
               
             $lastid = $wpdb->insert_id;
        }

         echo json_encode(array('result'=>$lastid));

    }
    else
        echo json_encode(array('result'=>0));

    exit;
}

function fam_matrix_data_delete()
{
    global $wpdb;

    $id = $_POST['rid'];

    $matrix_table = $wpdb->prefix."fam_matrix_values";

    $wpdb->query("DELETE FROM ".$matrix_table." WHERE id=".$id);

    echo 'ok'; exit;
}

 add_shortcode( 'maturity_matrix', 'maturity_matrix_table' );

 function maturity_matrix_table($att)
 {
   

    $matrix_id = isset($att['matrix']) ? $att['matrix'] : 0;
    $instance_id = isset($att['instance']) ? $att['instance'] : 0;

    global $wpdb;

    $matrix_table = $wpdb->prefix . "fam_matrix";

    $matrix_list  =  $wpdb->get_results("SELECT * FROM ".$matrix_table." WHERE id=".$matrix_id);

    if(count($matrix_list) > 0)
    {
         ob_start();
         $short=1;$matid=$matrix_list[0]->id;$instance=$instance_id;
        require('front_matrix.php');

       
       // admin_matrix_area(1,$matrix_list[0]->id,$instance_id);

        $output = ob_get_clean();    
        return $output;

        
    }
    else
        return '<p style="color:red;">Matrix not available.</p>';


 }

    include_once('admin_matrix.php');
    include_once('admin_add_instance.php');
    include_once('admin_documentation.php');